<template>
  <v-card>
    <v-toolbar flat>
      <v-toolbar-title>
        Participants
      </v-toolbar-title>
      <v-spacer />
      <v-toolbar-items />
      <v-select
        v-model="selectedGroup"
        :items="groups"
        item-text="name"
        label="Group"
        single-line
        return-object
        hide-details
        clearable
        flat
        class="mr-6"
      />
      <v-text-field
        v-model="search"
        append-icon="search"
        label="Search"
        single-line
        hide-details
        class="mr-6"
      />
      <student-list-reverse-mapper />
      <v-btn
        icon
        @click="refresh"
      >
        <v-icon>refresh</v-icon>
      </v-btn>
      <student-list-menu />
    </v-toolbar>
    <v-divider />
    <v-data-table
      :headers="headers"
      :items="studentList"
      :search="search"
      sort-by="name"
      :loading="loading"
      item-key="name"
      show-expand
      must-sort
    >
      <template #item="{ expand, isExpanded, item }">
        <tr>
          <td>
            <v-btn
              small
              icon
              @click="expand(!isExpanded)"
            >
              <v-icon v-if="isExpanded">
                keyboard_arrow_up
              </v-icon>
              <v-icon v-else>
                keyboard_arrow_down
              </v-icon>
            </v-btn>
          </td>
          <td>
            {{ item.name }}
          </td>
          <v-select
            v-model="item.exerciseGroups"
            item-text="name"
            item-value="pk"
            :items="groups"
            label="Set Groups"
            single-line
            return-object
            multiple
            chips
            dense
            hide-details
            filled
            @change="setExerciseGroups($event, item)"
          />
          <td>
            <v-tooltip top>
              <template #activator="{ on }">
                <div v-on="on">
                  <v-icon
                    v-if="item.isActive"
                    small
                  >
                    lock_open
                  </v-icon>
                  <v-icon
                    v-else
                    small
                  >
                    lock
                  </v-icon>
                </div>
              </template>
              <span v-if="!item.isActive">Participant doesn't have access.</span>
              <span v-else>Participant has access.</span>
            </v-tooltip>
          </td>
          <td
            v-for="type in submissionTypeHeaders"
            :key="type.pk"
            class="text-right"
          >
            <v-btn
              v-if="item[type.pk]"
              small
              rounded
              outlined
              class="submission-button"
              exact
              :to="{name: 'submission-side-view', params: {
                studentPk: item.pk,
                submissionPk: item[type.pk].pk
              }}"
              :color="item[type.pk].final ? 'green darken-2' : 'grey'"
              @click="showSubmissionDetails"
            >
              {{ item[type.pk].score }}
            </v-btn>
            <span v-else>N.A</span>
          </td>
          <td class="text-right">
            {{ item.total }}
          </td>
        </tr>
      </template>
      <template #expanded-item="{ headers, item }">
        <td :colspan="headers.length">
          <v-btn
            v-if="isReviever"
            @click="changeActiveStatus(item)"
          >
            {{ item.isActive ? 'Revoke access' : 'Grant access' }}
          </v-btn>
          <ul class="student-info-list">
            <li>
              <b>Modul:</b> {{ item.exam }}
            </li>
            <li>
              <b>MatrikelNr:</b> {{ item.matrikelNo }}
            </li>
          </ul>
        </td>
      </template>
    </v-data-table>
  </v-card>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import StudentListMenu from '@/components/student_list/StudentListMenu'
import StudentListReverseMapper from '@/components/student_list/StudentListReverseMapper'
import { changeActiveForUser, fetchUser, setGroups, fetchUserGroups} from '@/api'
import { getters } from '@/store/getters'
import { Authentication } from '@/store/modules/authentication'
import { ConfigModule } from '../../store/modules/config'
import * as api from '@/api'
import { Assignments } from '@/store/modules/assignments'


export default {
  name: 'StudentList',
  components: {
    StudentListReverseMapper,
    StudentListMenu },
  data () {
    return {
      loading: true,
      search: '',
      selectedGroup: null,
      userData: [],
      userMap: null,
      studentList: [],
      user: null
    }
  },
  computed: {
    ...mapState([
      'students'
    ]),
    studentListItems (){
      return this.studentList
    },
    isReviever() {
      return Authentication.isReviewer
    },
    submissionTypeHeaders () {
      const subTypes = Object.values(getters.state.submissionTypes)
      return subTypes
        .filter(submissionType => {
          return submissionType.examType.moduleReference === ConfigModule.state.config.currentExam
        })
        .sort((a, b) => a.name.localeCompare(b.name))
        .map(type => {
          return {
            pk: type.pk,
            text: type.name.substr(0, 5),
            value: `${type.pk}.score`,
            align: 'right'
          }
        })
    },
    headers () {
      return [
        {
          text: 'Name',
          align: 'left',
          value: 'name',
        },
        {
          text: 'Group',
          align: 'left',
          value: 'exerciseGroup'
        },
        {
          text: 'Has Access',
          align: 'left',
          value: 'isActive',
        },
        ...this.submissionTypeHeaders,
        {
          text: 'Total',
          align: 'right',
          value: 'total',
        },
      ]
    },
    groups () {
      if (Authentication.isTutor) {
        return Authentication.state.user.exerciseGroups.filter( group => {
            return group.exam === null || group.exam.pk === ConfigModule.state.config.examId
          })
      }
      else if (Authentication.isReviewer) {
        return Assignments.state.groups.filter( group => {
            return group.exam === null || group.exam.pk === ConfigModule.state.config.examId
          })
      }
      else {
        return []
      }
    },
  },
  created () {
    this.getUserData()
    this.getStudents().then(() => { 
      this.loading = false 
      this.getStudentListItems()
      })
    const groups = Assignments.getGroups()
  },
  methods: {
    ...mapActions([
      'getStudents'
    ]),
    async userAccountGroups(student) {
      return await (await fetchUser(student.userPk)).exerciseGroups
    },
    async getStudentListItems () {  
      if (!this.loading) { 
        let filteredStudents = this.students
        if (this.selectedGroup !== null) {
          filteredStudents = Object.values(filteredStudents).filter(student => {
            let userGroups = this.userMap.get(student.userPk)
            return userGroups.some(group => group.pk === this.selectedGroup.pk)
          })
        }
        console.log(filteredStudents)
        this.studentList = Object.values(filteredStudents).map(student => {
          console.log(student)
          return {
            pk: student.pk,
            user: student.user,
            userPk: student.userPk,
            exam: student.exam,
            name: student.name,
            isActive: student.isActive,
            exerciseGroups: ["3175670b-c405-4756-9c5d-7bd50143f0f8"],
            matrikelNo: student.matrikelNo,
            ...this.reduceArrToDict(student.submissions, 'type'),
            total: this.sumSubmissionScores(student.submissions)
          }
        })
      }
    },
    async getUser (student) {
      this.user = await fetchUser(student.userPk)
    },
    setExerciseGroups (groups, student) {
      console.log(groups)
      groups = groups.shift()
      this.getUser(student).then(() => {
        setGroups(this.user.pk, groups)
      })
    },
    reduceArrToDict (arr, key) {
      return arr.reduce((acc, curr) => {
        const keyInDict = curr[key]
        acc[keyInDict] = curr
        return acc
      }, {})
    },
    changeActiveStatus (student) {
      changeActiveForUser(student.userPk, !student.isActive).then(() => {
        this.getStudents({ studentPks: [student.pk] })
      }).catch(() => {
        this.$notify({
          title: 'Error',
          text: `Unable to change active status of ${student.user}`,
          type: 'error'
        })
      })
    },
    sumSubmissionScores (submissions) {
      submissions = submissions.filter(submission => {
        var subType = Object.values(getters.state.submissionTypes).filter(submissionType => {
          return submissionType.pk === submission.type
        })[0]
        return subType.examType.moduleReference === ConfigModule.state.config.currentExam
      })
      return submissions.reduce((acc, curr) => {
        if (curr.score) {
          acc += curr.score
        }
        return acc
      }, 0)
    },
    refresh (opts = { silent: false }) {
      if (!opts.silent) {
        this.loading = true
      }
      this.getStudents().then(() => { this.loading = false })
    },
    showSubmissionDetails () {
      this.$emit('detail-click')
    },
    async getUserData() {
      this.userMap = new Map()
      this.userData = await api.fetchUsers()
      var that = this // javascript this is not the same in forEach
      this.userData.forEach(user => {
        that.userMap.set(user.pk, user.exerciseGroups)
      })
    }
  },
}
</script>

<style scoped>
  .submission-button {
    min-width: 40px;
  }
  .student-info-list li {
    display: inline;
    margin-right: 20px;
  }
  .student-info-list {
    display: inline;
  }
</style>
